<?php

add_action('template_redirect', 'pcl_activate_lock');
function pcl_activate_lock() {
	global $post;
	
	if ( is_page() || is_single() ) {
		$meta = get_post_meta($post->ID, 'pcl_meta', true);
		if ( pcl_isset($meta['is_locked']) != 1 )
			return;
		
		if ( pcl_isset($meta['lock_mode']) == 'popup' ) {
			if ( pcl_isset($meta['unlock_type']) == 'optin' )
				pcl_pop_optin_lock();
			else
				add_action('wp_footer', 'pcl_pop_direct_lock');
		} else {
			if ( pcl_isset($meta['unlock_type']) == 'optin' )
				add_filter('the_content', 'pcl_optin_lock', 90);
			else
				add_filter('the_content', 'pcl_direct_lock', 90);
		}
	}
}

function pcl_pop_direct_lock() {
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return;
	
	// vars
	$cookie_hash = md5('unlocked' . $post->ID);
	$share = pcl_isset($meta['share']);
	
	// check for cookie
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) )
		return;
	
	$cta = stripslashes( pcl_isset($meta['share_cta']) );
	$share_url = ( pcl_isset($meta['share_url']) != '' ) ? $meta['share_url'] : get_permalink($post->ID);
	$tweet_msg = ( pcl_isset($meta['twitter']['msg']) != '' ) ? trim(stripslashes(strip_tags(esc_attr($meta['twitter']['msg'])))) : $post->post_title;
	$tweet_msg = str_replace('%share_url%', $share_url, $tweet_msg);
	
	$lock_content = '';
	$lock_content .= '<div id="pcl-popup-locker" style="display:none">';
	$lock_content .= '<div id="pcl-pop-share-locker" style="max-height:480px; overflow:auto;">' . "\n\n";
	$lock_content .= do_shortcode($cta);
	
	$place_width = 0;
	if ( pcl_share_use(pcl_isset($share['fb_like'])) ) $place_width += 120;
	if ( pcl_share_use(pcl_isset($share['fb_share'])) ) $place_width += 120;
	if ( pcl_share_use(pcl_isset($share['twitter'])) ) $place_width += 120;
	if ( pcl_share_use(pcl_isset($share['google1'])) ) $place_width += 120;
	
	$lock_content .= '<div style="width:' . $place_width . 'px; margin:5px auto 18px auto">';
	
	$lock_content .= '<table id="pcl-share-area"><tr>';
	if ( pcl_share_use($share['fb_like']) ) {
		$lock_content .= '<td><div class="fb-like" data-layout="button_count" data-send="false" data-href="' . $share_url . '" data-width="70" data-show-faces="false"></div></td>';
	}
	
	if ( pcl_share_use($share['fb_share']) ) {
		$lock_content .= '<td><a href="#" class="pcl-fb-share">Share</a><div class="pcl_count-o enabled" id="c"><i></i><u></u>'.pcl_facebook_count($share_url).'</div></td>';
	}
	
	if ( pcl_share_use($share['google1']) ) {
		$lock_content .= '<td><div style="max-width:80px; margin:0 auto"><g:plusone href="' . $share_url . '" size="medium" callback="pclUnlock" onendinteraction="pclGoogleEnd"></g:plusone></div></td>';
	}
	
	if ( pcl_share_use($share['twitter']) ) {
		$lock_content .= '<td><a href="https://twitter.com/share" class="twitter-share-button" data-url="' . $share_url . '" data-text="' . $tweet_msg . '">Tweet</a></td>';
	}

	$lock_content .= '</tr></table>';
	$lock_content .= '<div style="clear:left"></div>';
	$lock_content .= '</div>';
	$lock_content .= '</div>';
	$lock_content .= pcl_powered( 'pop', false);
	$lock_content .= '</div>';
	
	echo pcl_content_formatter($lock_content);
}

function pcl_facebook_count($share_url) {
	$facebook = @file_get_contents('http://api.facebook.com/restserver.php?method=links.getStats&urls='.$share_url);
	$fbbegin = '<share_count>';
	$fbend = '</share_count>';
	$fbpage = $facebook;
	$fbparts = explode($fbbegin,$fbpage);
	$fbpage = pcl_isset($fbparts[1]);
	$fbparts = explode($fbend,$fbpage);
	$fbcount = $fbparts[0];
	if($fbcount == '') { $fbcount = '0'; }
	
	return pcl_format_number($fbcount);
}

function pcl_format_number($number) {
    
    if ($number >= 1000000000) {
        $number = number_format(($number/1000000000), 1, '.', ',').'G';
    }
    if ($number >= 1000000) {
        $number = number_format(($number/1000000), 1, '.', ',').'M';
    }
    if ($number >= 1000) {
        $number = number_format(($number/1000), 1, '.', ',').'K';
    }
	
    return $number;
}

function pcl_pop_optin_lock() {
	add_action('wp_footer', 'pcl_popup_optin');
	add_filter('the_content', 'pcl_pop_optin_msg');
}

function pcl_pop_optin_msg($post_content) {
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	
	$output = '';
	if ( pcl_isset($meta['optinmsg']) != '' ) {
		$message = trim(stripslashes($meta['optinmsg']));
		$output .= '<div id="pcl-optin-msg" style="display:none"><strong>' . $message . '</strong></div>';
	}
	
	$output .= $post_content;
	
	return $output;
}

function pcl_popup_optin() {
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return;
	
	$cookie_hash = md5('unlocked' . $post->ID);
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) )
		return;
	
	$cta = stripslashes( pcl_isset($meta['optin_cta']) );
	$resp = pcl_extract_fields( pcl_isset($meta['resp_code']), pcl_isset($meta['name_field']), pcl_isset($meta['email_field']) );
	
	$lock_content = '';
	$lock_content .= '<div id="pcl-popup-locker" style="display:none">';
	$lock_content .= '<div id="pcl-pop-optin-locker" style="max-height:480px; overflow:auto;">' . "\n\n";
	$lock_content .= do_shortcode($cta);
	$lock_content .= '<div id="pcl-optin-form">' . pcl_optin_form( $resp, pcl_isset($meta['manual_subs']), pcl_isset($meta['btn_color']), pcl_isset($meta['btn_label']) ) . '</div>';
	
	if ( pcl_isset($meta['fb_subs']) == 1 ) :
		$lock_content .= '<div class="pcl_optin_facebook">';
		if ( pcl_isset($meta['fb_subs_title']) != '' ) {
			$lock_content .= '<p class="pcl_optin_fb_title">' . $meta['fb_subs_title'] . '</p>';
		}
		
		$lock_content .= '<button class="pcl-facebook-btn" name="pcl-fb-unlock" id="pcl-fb-unlock">' . pcl_isset($meta['fb_subs_label']) . '</button>';
		$lock_content .= '</div>';
	endif;
		
	$lock_content .= '<p class="pcl-privacy">' . $meta['privacy'] . '</p>';
	$lock_content .= '</div>';
	$lock_content .= pcl_powered( 'pop', false);
	$lock_content .= '</div>';
	
	echo pcl_content_formatter($lock_content);
}

function pcl_optin_form( $resp, $method, $btn_color, $btn_label ) {
	if ( $resp == '' )
		return '';
	
	$html = '';
	$html .= '[raw]<form method="post" id="pcl-ar-submit" action="' . pcl_isset($resp['action']) . '" target="pclOptinTargetFrame">[/raw]' . "\n";
	if ( isset($resp['fields']) && is_array($resp['fields']) && count($resp['fields']) > 0 ) {
		foreach ( $resp['fields'] as $k => $v ) {
			$field_id = ( stristr( $k, 'mail') || stristr( $k, 'from') ) ? 'pcl_email' : 'pcl_name';
			$field_class = ( stristr( $k, 'mail') || stristr( $k, 'from') ) ? 'pcl-email' : 'pcl-name';
			if ( $method != 1 )
				$html .= '[raw]<input type="hidden" name="' . $k . '" value="' . stripslashes($v) . '" id="' . $field_id . '" class="' . $field_class . '" />[/raw]' . "\n";
			else
				$html .= '[raw]<input type="text" name="' . $k . '" value="' . stripslashes($v) . '" id="' . $field_id . '" class="pcl-text-field ' . $field_class . '" onfocus="if ( this.value == \'' . stripslashes($v) . '\') this.value = \'\';" onblur="if ( this.value == \'\') this.value = \'' . stripslashes($v) . '\';" />[/raw]' . "\n";
		}
	}

	if ( isset($resp['hiddens']) && is_array($resp['hiddens']) && count($resp['hiddens']) > 0 ) {
		foreach ( $resp['hiddens'] as $k => $v ) {
			$html .= '[raw]<input type="hidden" name="' . $k . '" value="' . $v . '" />[/raw]' . "\n";
		}
	}

	if ( $method == 1 ) {		
			$html .= '[raw]<a href="#" name="pcl-optin-submit" id="pcl-optin-submit" class="pcl-btn pcl-btn-' . $btn_color . '" /><span>' . stripslashes($btn_label) . '</span></a>[/raw]' . "\n";
	}
	
	$html .= '[raw]</form>[/raw]';
	$html .= '[raw]<iframe id="pclOptinTargetFrame" style="display:none" name="pclOptinTargetFrame" src="about:blank"></iframe>[/raw]';
	
	return pcl_content_formatter($html);
}

function pcl_optin_lock( $post_content ) {
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return $post_content;
	
	$cookie_hash = md5('unlocked' . $post->ID);
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) )
		return $post_content;
	
	add_filter('the_content', 'pcl_content_formatter', 99);
	$cta = stripslashes( pcl_isset($meta['optin_cta']) );
	$resp = pcl_extract_fields( pcl_isset($meta['resp_code']), pcl_isset($meta['name_field']), pcl_isset($meta['email_field']) );
	$message = trim(stripslashes($meta['optinmsg']));
	
	$lock_content = '';
	$lock_content .= '<div id="pcl-locked-content" style="display:none;">' . "\n\n";
	$lock_content .= '<div id="pcl-optin-msg" style="display:none"><strong>' . $message . '</strong></div>' . "\n\n";
	$lock_content .= $post_content . "\n\n" . '</div>';
	$lock_content .= '<div id="pcl-optin-locker">' . "\n\n";
	$lock_content .= do_shortcode($cta);
	$lock_content .= '[raw]<div id="pcl-optin-form">' . pcl_optin_form( $resp, pcl_isset($meta['manual_subs']), pcl_isset($meta['btn_color']), pcl_isset($meta['btn_label']) ) . '</div>[/raw]';
	
	if ( pcl_isset($meta['fb_subs']) == 1 ) :
		$lock_content .= '[raw]<div class="pcl_optin_facebook">[/raw]';
		if ( pcl_isset($meta['fb_subs_title']) != '' ) {
			$lock_content .= '[raw]<p class="pcl_optin_fb_title">' . $meta['fb_subs_title'] . '</p>[/raw]';
		}
		
		$lock_content .= '[raw]<button class="pcl-facebook-btn" name="pcl-fb-unlock" id="pcl-fb-unlock">' . pcl_isset($meta['fb_subs_label']) . '</button>[/raw]';
		$lock_content .= '[raw]</div>[/raw]';
	endif;
		
	$lock_content .= '[raw]<p class="pcl-privacy">' . $meta['privacy'] . '</p>[/raw]';
	$lock_content .= pcl_powered( 'direct', false );
	$lock_content .= '</div>';
	
	
	return $lock_content;
}

function pcl_direct_lock( $post_content ) {
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return $post_content;
	
	// vars
	$cookie_hash = md5('unlocked' . $post->ID);
	$share = pcl_isset($meta['share']);
	
	// check for cookie
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) )
		return $post_content;
	
	add_filter('the_content', 'pcl_content_formatter', 99);
	$cta = stripslashes( pcl_isset($meta['share_cta']) );
	$share_url = ( pcl_isset($meta['share_url']) != '' ) ? $meta['share_url'] : get_permalink($post->ID);
	$tweet_msg = ( pcl_isset($meta['twitter']['msg']) != '' ) ? trim(stripslashes(strip_tags(esc_attr($meta['twitter']['msg'])))) : $post->post_title;
	$tweet_msg = str_replace('%share_url%', $share_url, $tweet_msg);
	
	$lock_content = '';
	$lock_content .= '<div id="pcl-locked-content" style="display:none;">' . "\n" . $post_content . "\n" . '</div>';
	$lock_content .= '<div id="pcl-share-locker">' . "\n\n";
	$lock_content .= do_shortcode($cta);
	
	$place_width = 0;
	if ( pcl_share_use(pcl_isset($share['fb_like'])) ) $place_width += 120;
	if ( pcl_share_use(pcl_isset($share['fb_share'])) ) $place_width += 120;
	if ( pcl_share_use(pcl_isset($share['twitter'])) ) $place_width += 120;
	if ( pcl_share_use(pcl_isset($share['google1'])) ) $place_width += 120;
	
	$lock_content .= '<div style="width:' . $place_width . 'px; margin:5px auto 18px">';
	
	$lock_content .= '<table id="pcl-share-area"><tr>';
	if ( pcl_share_use($share['fb_like']) ) {
		$lock_content .= '<td><div class="fb-like" data-layout="button_count" data-send="false" data-href="' . $share_url . '" data-width="70" data-show-faces="false"></div></td>';
	}
	
	if ( pcl_share_use($share['fb_share']) ) {
		$lock_content .= '<td><a href="#" class="pcl-fb-share">Share</a><div class="pcl_count-o enabled" id="c"><i></i><u></u>'.pcl_facebook_count($share_url).'</div></td>';
	}
	
	if ( pcl_share_use($share['google1']) ) {
		$lock_content .= '<td><div style="max-width:80px; margin:0 auto"><g:plusone href="' . $share_url . '" size="medium" callback="pclUnlock" onendinteraction="pclGoogleEnd"></g:plusone></div></td>';
	}
	
	if ( pcl_share_use($share['twitter']) ) {
		$lock_content .= '<td><a href="https://twitter.com/share" class="twitter-share-button" data-url="' . $share_url . '" data-text="' . $tweet_msg . '">Tweet</a></td>';
	}

	$lock_content .= '</tr></table>';
	$lock_content .= '<div style="clear:left"></div>';
	$lock_content .= '</div>';
	$lock_content .= pcl_powered( 'direct', false );
	$lock_content .= '</div>';
	return $lock_content;
}

function pcl_share_use( $share ) {
	if ( pcl_isset($share) == 1 )
		return true;
	
	return false;
}

add_action('init', 'pcl_facebook_channel');
function pcl_facebook_channel() {
	if ( pcl_isset($_GET['plugin']) == 'pcl' && pcl_isset($_GET['mode']) == 'fb_channel' ) {
 		$cache_expire = 60*60*24*365;
		header("Pragma: public");
		header("Cache-Control: max-age=".$cache_expire);
		header('Expires: ' . gmdate('D, d M Y H:i:s', time()+$cache_expire) . ' GMT');
		
		$locale = pcl_get_locale();
		if ( !$locale )
			return;
	
 		echo '<script src="//connect.facebook.net/en_US/all.js"></script>';
		exit;
	}	
}

add_filter('language_attributes', 'pcl_facebook_attribute', 100);
function pcl_facebook_attribute( $content ) {
	if ( !is_page() && !is_single() )
		return $content;
	
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return $content;
	
	if ( preg_match( '/xmlns:fb="(.*)"/', $content ) )
		return $content;
		
	$content .= ' xmlns:fb="http://www.facebook.com/2008/fbml"';
	return $content;
}

add_filter('language_attributes', 'pcl_opengraph_attribute', 100);
function pcl_opengraph_attribute( $content ) {
	if ( !is_page() && !is_single() )
		return $content;
		
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return $content;
		
	if ( preg_match( '/xmlns:og="(.*)"/', $content ) ) return $content;
  	$content .= ' xmlns:og="http://ogp.me/ns#"';
	return $content;
}

function pcl_get_post_image() {
	global $post;
	
	if (isset($post->ID)){
		if ( !function_exists('has_post_thumbnail') )
			require_once (ABSPATH . 'wp-includes/post-thumbnail-template.php');
		
		$post_thumbnail_id = get_post_thumbnail_id( $post->ID );
		$src = wp_get_attachment_image_src( $post_thumbnail_id );
		$image = '';
		if ( has_post_thumbnail($post->ID) ) {
				$image = $src[0];
		} else {
				$output = preg_match_all( '/<img.+src=[\'"]([^\'"]+)[\'"].*>/i', $post->post_content, $matches );
				$image = pcl_isset($matches[1][0]);
		}
	
		return $image;
	}
	
	return false;
}

add_action('wp_head', 'pcl_opengraph_meta', 90);
function pcl_opengraph_meta() {
	if ( !is_page() && !is_single() )
		return '';
		
	global $post;
	
	$pcl = get_option('pcl_settings');
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return '';
	
	$share_url = get_permalink($post->ID);
	$share_title = esc_attr(wptexturize(strip_tags(stripslashes($post->post_title))));
	$share_image = pcl_get_post_image();
	$share_desc = strip_tags(str_replace(array("\n", "\r"), ' ', $post->post_content));
	$share_desc = substr($share_desc, 0, 160);
	$share_desc = esc_attr(wptexturize(strip_shortcodes(strip_tags(stripslashes($share_desc)))));
	
	echo "\n\n" . '<meta property="fb:app_id" content="' . pcl_isset($pcl['fb_appid']) . '" />' . "\n";
  	echo '<meta property="og:title" content="' . $share_title . '" />' . "\n"; 
  	if ( $share_image !== FALSE ) echo '<meta property="og:image" content="' . $share_image . '" />' . "\n";
  	echo '<meta property="og:description" content="' . $share_desc . '" />' . "\n";
  	echo '<meta property="og:url" content="' . $share_url . '" />' . "\n";
	echo '<meta property="og:type" content="website" />' . "\n";
	echo '<meta property="og:site_name" content="' . get_bloginfo('name') . '"/>' . "\n";
}

add_action('pcl_fb_action', 'pcl_fblike_unlock');
function pcl_fblike_unlock() {
	if ( !is_page() && !is_single() )
		return '';
	
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return '';
	
	$cookie_hash = md5('unlocked' . $post->ID);
	$url = get_permalink($post->ID);
	
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) )
		return '';
?>
	<?php if ( pcl_isset($meta['unlock_type']) != 'optin' ) : ?>
		FB.Event.subscribe('edge.create', function(response) {
			jQuery.cookie('pcl_<?php echo $cookie_hash; ?>', 1, { expires: 365, path: '<?php echo SITECOOKIEPATH; ?>' });
			pclRedirect();
		});
	<?php endif; ?>
<?php
}

add_action('pcl_fb_functions', 'pcl_facebook_js', 5);
function pcl_facebook_js() {
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	$pcl = get_option('pcl_settings');
	$cookie_hash = md5('unlocked' . $post->ID);
	
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) ) return '';
	if ( pcl_isset($meta['share']['fb_share']) != 1 && pcl_isset($meta['fb_subs']) != 1 ) return '';

	$desc = strip_shortcodes(strip_tags(str_replace(array("\n", "\r"), ' ', $post->post_content)));
	$desc = substr($desc, 0, 160);
	
	$share_url = ( pcl_isset($meta['share_url']) != '' ) ? $meta['share_url'] : get_permalink($post->ID);
	$share_title = ( pcl_isset($meta['fb_share']['title']) != '' ) ? esc_attr(strip_tags(stripslashes($meta['fb_share']['title']))) : ( ( $share_url == get_permalink($post->ID) ) ? $post->post_title : '');
	$share_desc = ( pcl_isset($meta['fb_share']['desc']) != '' ) ? esc_attr(strip_tags(stripslashes($meta['fb_share']['desc']))) : ( ( $share_url == get_permalink($post->ID) ) ? $desc : '');
	
	$fb_link = 'link: "' . trim($share_url) . '",';
	$fb_title = ( $share_title != '' ) ? 'name: "' . addslashes(strip_shortcodes(trim($share_title))) . '",' : '';
	$fb_image = ( pcl_isset($meta['image']) != '' ) ? 'picture: "' . trim(pcl_isset($meta['image'])) . '",' : '';
	$fb_desc = ( $share_desc != '' ) ? 'description: "' . addslashes(strip_shortcodes(trim($share_desc))) . '"' : '';
	
	$exit_cmd = ( pcl_isset($meta['lock_mode']) == 'popup' ) ? 'pclDisablePopup(jQuery);' : "\njQuery('#pcl-share-locker').hide();\njQuery('#pcl-optin-locker').hide();\njQuery('#pcl-locked-content').fadeIn();\njQuery('#pcl-optin-msg').fadeIn();";
	
	$script = '';
	
	if ( pcl_isset($meta['unlock_type']) == 'share' && pcl_isset($meta['share']['fb_share']) == 1 ) :
		$script .= "
			function pcl_facebook_share_login($) {
				FB.login(function(response) {
					if ( response.authResponse ) {
						if ( response.status == 'connected' ) {	
							pcl_facebook_share($, 'no');
						}
					}
				}, {scope: 'email,publish_stream'});
			}
			";
	endif;
	
	if ( pcl_isset($meta['share']['fb_share']) == 1 || pcl_isset($meta['fb_subs']) == 1 ) :
	$script .= "
		function pcl_facebook_share($, notif) {
			FB.api('/me/feed', 'post', {
				{$fb_link}
				{$fb_image}
				{$fb_title}
				caption : '',
				{$fb_desc}
			}, function(response) {
				if ( notif == 'yes' ) { alert('Thank you. Click \"OK\" to unlock the content.'); }
				$.cookie('pcl_{$cookie_hash}', 1, { expires: 365, path: '" . SITECOOKIEPATH . "' });
				{$exit_cmd}
			});
		}
		";
	endif;
	
	if ( pcl_isset($meta['unlock_type']) == 'optin' && pcl_isset($meta['fb_subs']) == 1 ) :
		$optin_shared = ( pcl_isset($meta['fbopt_share']) == 1 ) ? "\n" . 'pcl_facebook_share($, \'no\')' . "\n" : '';
		$optin_cookie = ( pcl_isset($meta['fbopt_share']) == 1 ) ? '' : "";
		$script .= "
			function pcl_facebook_optin_login($) {
				FB.login(function(response) {
					if ( response.authResponse ) {
						if ( response.status == 'connected' ) {
							pcl_facebook_optin($);
						}
					}
				}, {scope: 'email,publish_stream'});
			}
		";
		
		$script .= "
			function pcl_facebook_optin($) {
				FB.api('/me', function(response) {
					{$optin_shared}
					var pcl_name  = response.first_name;
					var pcl_email = response.email;
					$('.pcl-name').val(pcl_name);
					$('.pcl-email').val(pcl_email);
					$.cookie('pcl_{$cookie_hash}', 1, { expires: 365, path: '" . SITECOOKIEPATH . "' });		
					setTimeout(function(){
						document.getElementById('pcl-ar-submit').submit();
						{$exit_cmd}
					}, 2000);
				});
			}
		";
	endif;
	
	/*	
	echo '
		<script type="text/javascript">
		' . $script . '
		</script>
	';
	*/
	echo "\n\n" . $script . "\n\n";
}	

add_action('pcl_fb_action', 'pcl_facebook_share');
function pcl_facebook_share(){
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return '';
	
	$pcl = get_option('pcl_settings');
	$cookie_hash = md5('unlocked' . $post->ID);
	
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) ) return '';
	if ( pcl_isset($meta['unlock_type']) == 'optin' ) return '';
	if ( pcl_isset($meta['share']['fb_share']) != 1 ) return '';
	
	$script = '';
	$script .= "
			jQuery('.pcl-fb-share').click(function(e){
				FB.getLoginStatus(function(response) {
					if ( response.status == 'connected' ) {
						pcl_facebook_share(jQuery, 'yes');
					} else {
						pcl_facebook_share_login(jQuery);
					}
				});
				e.preventDefault();
			});
	";

	echo $script;
}

add_action('pcl_fb_action', 'pcl_facebook_optin');
function pcl_facebook_optin(){
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return '';
	
	$pcl = get_option('pcl_settings');
	$cookie_hash = md5('unlocked' . $post->ID);
	
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) ) return '';
	if ( pcl_isset($meta['unlock_type']) == 'share' ) return '';
	if ( pcl_isset($meta['fb_subs']) != 1 ) return '';
?>
	jQuery('#pcl-fb-unlock').click(function(e){
		FB.getLoginStatus(function(response) {
			if ( response.status == 'connected' ) {
				pcl_facebook_optin(jQuery);
			} else {
				pcl_facebook_optin_login(jQuery);
			}
			e.preventDefault();
		});
	});
<?php
}

add_action('wp_footer', 'pcl_unlock_script', 20);
function pcl_unlock_script() {
	if ( !is_page() && !is_single() )
		return '';
	
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return '';
	
	$pcl = get_option('pcl_settings');
	$cookie_hash = md5('unlocked' . $post->ID);
	$url = get_permalink($post->ID);
	
	if ( isset($_COOKIE['pcl_' . $cookie_hash]) )
		return '';
	
	$channelURL = pcl_format_url(get_option('siteurl'), 'plugin=pcl&mode=fb_channel');
?>
<div id="fb-root"></div>
<script type="text/javascript">
	window.fbAsyncInit = function() {
	    FB.init({
		      appId      : '<?php echo stripslashes($pcl['fb_appid']); ?>', // App ID
		      channelUrl : '<?php echo $channelURL; ?>', // Channel File
		      status     : true, // check login status
		      cookie     : true, // enable cookies to allow the server to access the session
		      xfbml      : true  // parse XFBML
		});

    	<?php do_action('pcl_fb_action'); ?>
  	};
    	
	(function(d){
	     var js, id = 'facebook-jssdk', ref = d.getElementsByTagName('script')[0];
	     if (d.getElementById(id)) {return;}
	     js = d.createElement('script'); js.id = id; js.async = true;
	     js.src = "//connect.facebook.net/en_US/all.js";
	     ref.parentNode.insertBefore(js, ref);
	}(document));
	
	<?php do_action('pcl_fb_functions'); ?>
</script>
<?php if ( pcl_isset($meta['unlock_type']) != 'optin' ) { ?>
<script>
window.twttr = (function (d,s,id) {
	var t, js, fjs = d.getElementsByTagName(s)[0];
    if (d.getElementById(id)) return; js=d.createElement(s); js.id=id;
    js.src="//platform.twitter.com/widgets.js"; fjs.parentNode.insertBefore(js, fjs);
    return window.twttr || (t = { _e: [], ready: function(f){ t._e.push(f) } });
}(document, "script", "twitter-wjs"));

twttr.ready(function (twttr) {
	twttr.events.bind('tweet', function(event) {
		jQuery.cookie('pcl_<?php echo $cookie_hash; ?>', 1, { expires: 365, path: '<?php echo SITECOOKIEPATH; ?>' });
		pclRedirect();
	});
});
</script>

<?php } else { ?>
<script>
	jQuery(document).ready(function($){
		$('#pcl-optin-submit').click(function(e){
			var field_name = $('.pcl-name');
			if ( field_name.length ) {
				if ( field_name.val().length < 2 ) {
					alert('Please enter your first name.');
					return false;
				}
			}

			var field_email = $('.pcl-email');
			var reg = /^([\w-]+(?:\.[\w-]+)*)@((?:[\w-]+\.)*\w[\w-]{0,66})\.([a-z]{2,6}(?:\.[a-z]{2})?)$/i;
			if ( !reg.test(field_email.val()) ) {
				alert('Please enter a valid email address.');
				return false;
			}

			jQuery.cookie('pcl_<?php echo $cookie_hash; ?>', 1, { expires: 365, path: '<?php echo SITECOOKIEPATH; ?>' });
			$('form#pcl-ar-submit').submit();
			pclRedirect();
			e.preventDefault();
		});
	});
</script>
<?php } ?>

<?php if ( pcl_isset($meta['lock_mode']) == 'popup' ) { ?>
<div id="pclBgPopup"></div>
<script type="text/javascript">
jQuery(document).ready(function($){
	$('#pclBgPopup').css({
		'position': 'fixed',
		'opacity': '0.9',
		'z-index': '9999',
		'background': '#000000',
		'width':'100%',
		'height':'100%',
		'top': '0px',
		'left': '0px',
	});
	
	var pos  = 'fixed';
	var top  = (($(window).height() / 2) - ($('#pcl-popup-locker').outerHeight() / 2));
	var left = (($(window).width() / 2) - ($('#pcl-popup-locker').outerWidth() / 2));

	if ( top < 0 ) top = 0;
	if ( left < 0 ) left = 0;

	// IE6 fix
	if ( $.browser.msie && parseInt($.browser.version) <= 6 ) {
		top = top + $(window).scrollTop();
		pos = 'absolute';
	}

	$('#pcl-popup-locker').css({
    	'position' : pos,
    	'top' : top,
    	'left' : left,
		'z-index': '999999'
	}).show();
});

function pclDisablePopup($) {
	$("#pclBgPopup").fadeOut("slow");
	$('#pcl-popup-locker').fadeOut("slow");
	$('#pcl-optin-msg').fadeIn();
}
</script>
<?php } ?>
<script type="text/javascript">
	function pclUnlock(e) {
		jQuery(document).ready(function(){
			if ( e.state == 'on' ) {
				jQuery.cookie('pcl_<?php echo $cookie_hash; ?>', 1, { expires: 365, path: '<?php echo SITECOOKIEPATH; ?>' });
			}
		});
	}
	
	function pclRedirect() {
		jQuery(document).ready(function(){
    	<?php if ( pcl_isset($meta['lock_mode']) == 'popup' ) { ?>
    			pclDisablePopup(jQuery);
    	<?php } else { ?>
    		jQuery('#pcl-share-locker').hide();
    		jQuery('#pcl-optin-locker').hide();
			jQuery('#pcl-locked-content').fadeIn();
			jQuery('#pcl-optin-msg').fadeIn();
    	<?php } ?>
    	});
	}
	
	function pclGoogleEnd(e){
		if ( e.type == 'confirm' && jQuery.cookie('<?php echo $cookie_hash; ?>') != '' ) {
			pclRedirect();
		}
	}
</script>
<script type="text/javascript" src="http://apis.google.com/js/plusone.js"></script>
<?php
}

function pcl_content_formatter($content) {
	$new_content = '';

	/* Matches the contents and the open and closing tags */
	$pattern_full = '{(\[raw\].*?\[/raw\])}is';

	/* Matches just the contents */
	$pattern_contents = '{\[raw\](.*?)\[/raw\]}is';

	/* Divide content into pieces */
	$pieces = preg_split($pattern_full, $content, -1, PREG_SPLIT_DELIM_CAPTURE);

	/* Loop over pieces */
	foreach ( $pieces as $piece ) {
		/* Look for presence of the shortcode */
		if ( preg_match($pattern_contents, $piece, $matches) ) {
			/* Append to content (no formatting) */
			$new_content .= $matches[1];
		} else {
			/* Format and append to content */
			$new_content .= wptexturize(wpautop($piece));
		}
	}

	return $new_content;
}

add_action('init', 'pcl_twitter_share');
function pcl_twitter_share(){
	if ( isset($_GET['pcl_ID']) && pcl_isset($_GET['share']) == 'twitter' && pcl_isset($_GET['action']) == 'tweet' ) {
		require_once PCL_PATH . 'inc/twitteroauth/twitteroauth.php';
		
		$pcl = get_option('pcl_settings');
		$tw_consumer = trim(pcl_isset($pcl['tw_consumer']));
		$tw_secret = trim(pcl_isset($pcl['tw_secret']));
		$post_id = (int) $_GET['pcl_ID'];
		$permalink = get_permalink($post_id);
		
		if ( !($_COOKIE['__pcl_twitter_id']) || ( $access_token = get_transient('access_token_' . pcl_isset($_COOKIE['__pcl_twitter_id'])) ) === FALSE ) {
			wp_redirect(pcl_format_url($post_id, "pcl_ID={$post_id}&share=twitter&action=oauth"));
			exit;
		}
		
		$connection = new TwitterOAuth($tw_consumer, $tw_secret, $access_token['oauth_token'], $access_token['oauth_token_secret']);
		$content = $connection->get('account/rate_limit_status');

		if ( $content->remaining_hits < 1 ) {
			echo "<script>alert('Could not connect to Twitter (reach limit). Please try again later.');\nwindow.location.href='{$permalink}';</script>";
			die;
		}
		
		$meta = get_post_meta($post_id, 'pcl_meta', true);
		$share_url = ( pcl_isset($meta['share_url']) != '' ) ? $meta['share_url'] : $permalink;
		$tweet_msg = ( pcl_isset($meta['twitter']['msg']) != '' ) ? trim(stripslashes(strip_tags(esc_attr($meta['twitter']['msg'])))) : get_the_title($post_id);
		$tweet_msg = str_replace('%share_url%', $share_url, $tweet_msg);
		
		$message = $tweet_msg . ' ' . $share_url;
		
		$parameters = array('status' => $message);
		$status = $connection->post('statuses/update', $parameters);
		$cookie_hash = md5('unlocked' . $post_id);
		
		@setcookie('pcl_' . $cookie_hash, 1, time()+60*60*24*365, SITECOOKIEPATH);
		wp_redirect($permalink);
		exit;
	}
}

add_action('init', 'pcl_twitter_oauth');
function pcl_twitter_oauth(){
	if ( isset($_GET['pcl_ID']) && pcl_isset($_GET['share']) == 'twitter' && pcl_isset($_GET['action']) == 'oauth' ) {
		
		// delete all cookies
		@setcookie('__pcl_oauth_token', '', time()-60*60*24*2, SITECOOKIEPATH);
		@setcookie('__pcl_oauth_token_secret', '', time()-60*60*24*2, SITECOOKIEPATH);
		
		// set unique id
		if ( !isset($_COOKIE['__pcl_twitter_id']) )
			@setcookie('__pcl_twitter_id', pcl_twitter_id(), time()+60*60*24*365, SITECOOKIEPATH);
		
		require_once PCL_PATH . 'inc/twitteroauth/twitteroauth.php';
		
		$pcl = get_option('pcl_settings');
		$tw_consumer = trim(pcl_isset($pcl['tw_consumer']));
		$tw_secret = trim(pcl_isset($pcl['tw_secret']));
		$post_id = (int) $_GET['pcl_ID'];
		$permalink = get_permalink($post_id);
		$callback_url = pcl_format_url($post_id, "pcl_ID={$post_id}&share=twitter&action=callback");
		
		$connection = new TwitterOAuth($tw_consumer, $tw_secret);
		$request_token = $connection->getRequestToken($callback_url);
		
		$oauth_token = $request_token['oauth_token'];
		$oauth_token_secret = $request_token['oauth_token_secret'];
		
		@setcookie('__pcl_oauth_token', $oauth_token, 0, SITECOOKIEPATH);
		@setcookie('__pcl_oauth_token_secret', $oauth_token_secret, 0, SITECOOKIEPATH);
		
		switch ( $connection->http_code ) {
  			case 200:
    			$auth_url = $connection->getAuthorizeURL($oauth_token);
    			wp_redirect($auth_url);
    			break;
  			default:
    			echo "<script>alert('Could not connect to Twitter. Refresh the page or try again later.');\nwindow.location.href='{$permalink}';</script>";
		}
		exit;
	}
}

add_action('init', 'pcl_twitter_callback');
function pcl_twitter_callback(){
	if ( isset($_GET['pcl_ID']) && pcl_isset($_GET['share']) == 'twitter' && pcl_isset($_GET['action']) == 'callback' ) {
		require_once PCL_PATH . 'inc/twitteroauth/twitteroauth.php';
		
		$pcl = get_option('pcl_settings');
		$tw_consumer = trim(pcl_isset($pcl['tw_consumer']));
		$tw_secret = trim(pcl_isset($pcl['tw_secret']));
		$post_id = (int) $_GET['pcl_ID'];
		$oauth_token = pcl_isset($_COOKIE['__pcl_oauth_token']);
		$oauth_token_secret = pcl_isset($_COOKIE['__pcl_oauth_token_secret']);
		
		$tweet_url = pcl_format_url($post_id, "pcl_ID={$post_id}&share=twitter&action=tweet");
		$auth_url = pcl_format_url($post_id, "pcl_ID={$post_id}&share=twitter&action=oauth");
		
		if ( isset($_GET['oauth_token']) && $oauth_token !== $_GET['oauth_token'] || !isset($_COOKIE['__pcl_twitter_id']) ) {
  			wp_redirect($auth_url);
			exit;
		}
		
		$connection = new TwitterOAuth($tw_consumer, $tw_secret, $oauth_token, $oauth_token_secret);
		$access_token = $connection->getAccessToken($_GET['oauth_verifier']);

		set_transient( 'access_token_' . $_COOKIE['__pcl_twitter_id'], $access_token, 60*60*24 );
		@setcookie('__pcl_oauth_token', '', time()-60*60*24*2, SITECOOKIEPATH);
		@setcookie('__pcl_oauth_token_secret', '', time()-60*60*24*2, SITECOOKIEPATH);
		
		if ( 200 == $connection->http_code ) {
  			wp_redirect($tweet_url);
		} else {
  			wp_redirect($auth_url);
		}
		exit;
	}
}

function pcl_twitter_id(){
	$host = $_SERVER['HTTP_HOST'];
	$ip = $_SERVER['REMOTE_ADDR'];
	$rand = md5($host . $ip . time());
	
	return $rand;
}

function pcl_powered( $mode = 'direct', $echo = true ) {
	$pcl = get_option('pcl_settings');
	
	if ( pcl_isset($pcl['is_not_powered']) == 1 ) return '';
	
	$target = ( pcl_isset($pcl['is_powered_self']) == 1 ) ? '_self' : '_blank';
	$url = ( pcl_isset($pcl['aff_link']) != '' ) ? trim(stripslashes(strip_tags(pcl_isset($pcl['aff_link'])))) : 'http://premiumcontentlock.com';
	$class = ( $mode == 'direct' ) ? 'pcl-powered-direct' : 'pcl-powered-pop';
	
	$content = '';
	$content .= '<div class="' . $class . '">Powered By <a href="' . $url . '" target="' . $target . '">Premium Content Lock</a></div>';
	
	if ( $echo )
		echo $content;
	else
		return $content;
}

function pcl_extract_fields( $code, $name_label, $email_label ) {
	if ( $code == '' ) return false;

	preg_match('/<form\s[^>]*action=[\'"]([^\'"]+)[\'"]/i', stripslashes( $code ), $form);
	preg_match_all('/<input\s[^>]*type=[\'"]?hidden[^>]*>/i', stripslashes( $code ), $hiddens);
	preg_match_all('/<input\s[^>]*type=([\'"])?(text|email)[^>]*>/i', stripslashes( $code ), $texts);
	
	// Text fields
	$fields = '';
	if ( !empty($texts[0]) ) {
		foreach( $texts[0] as $text ) {
			$name  = pcl_extract_attribute( $text, 'name' );

			if ( !is_array($fields) )
				$fields = array();

			$fields[$name] = ( stristr( $name, 'mail') || stristr( $name, 'from') ) ? $email_label : $name_label;
		}
	}

	// Hidden fields
	$values = '';
	if ( !empty($hiddens[0]) ) {
		foreach( $hiddens[0] as $hidden ) {
			$name  = pcl_extract_attribute( $hidden, 'name' );
			$value = pcl_extract_attribute( $hidden, 'value' );

			if ( !is_array($values) )
				$values = array();

			$values[$name] = $value;
		}
	}

	$post_data['action'] = pcl_isset($form[1]);
	$post_data['fields'] = $fields;
	$post_data['hiddens'] = $values;

	return $post_data;
}

function pcl_extract_attribute( $field, $attrib ) {
	$remove    = array($attrib . '=', '"', "'", "/>");
	$field     = str_replace("'", "\"", $field);
	$pos       = strpos($field, $attrib . "=");
	$filter    = substr_replace($field, "", 0, $pos);
	$pos2      = strpos($filter, " ");
	$pos2      = ( $pos2 != '' ) ? $pos2 : strpos($filter, ">");
	$attribute = substr_replace($filter, "", $pos2, 1000);
	$attribute = str_replace( $remove, '', $attribute );

	return $attribute;
}

if ( !is_admin() ) add_action('init', 'pcl_front_scripts');
function pcl_front_scripts() {
	wp_enqueue_script('jquery');
	wp_enqueue_script('jquery-cookie', PCL_URL . 'js/jquery.cookie.js');
}

add_action('wp_print_styles', 'pcl_front_styles');
function pcl_front_styles() {
	if ( !is_singular() )
		return;
	
	global $post;
	
	$meta = get_post_meta($post->ID, 'pcl_meta', true);
	if ( pcl_isset($meta['is_locked']) != 1 )
		return;
		
	wp_register_style('pcl-style', PCL_URL . 'css/pcl.css', array(), '1.0.0', 'all');
	wp_enqueue_style('pcl-style');
}

// HOOKS
