<?php if ( !defined('ABSPATH') ) die('No direct access');
function pcl_add_meta_box() {
	if ( !function_exists( 'add_meta_box' ) )
		return;

	add_meta_box( 'pcl-meta-box-page', 'Premium Content Lock', 'pcl_meta_box', 'page', 'normal', 'high' );
	add_meta_box( 'pcl-meta-box-post', 'Premium Content Lock', 'pcl_meta_box', 'post', 'normal', 'high' );
}

function pcl_meta_box( $post ) {
	$pcl = get_post_meta($post->ID, 'pcl_meta', true);

	echo '<input type="hidden" name="_pcl_meta_nonce" value="' . wp_create_nonce( 'pcl-meta-nonce' ) . '" />';
	echo '<input type="hidden" name="pcl_post_id" id="pcl_post_id" value="' . $post->ID . '" />';
?>
	<ul id="pcl-set">
	<li>
		<label><?php _e('Enable PCL', 'pcl'); ?></label>
		<label for="is_locked" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[is_locked]" id="is_locked" value="1"<?php if ( pcl_isset($pcl['is_locked']) == 1 ) echo ' checked="checked" '; ?>/> <span class="pcl-field-desc"><code><?php _e('Lock This Post/Page Content', 'pcl'); ?></code></span></label>
		<div class="pcl-field-desc"><?php _e('Enter the content you want to lock into the wordpress editor above.', 'pcl'); ?></div> 
		<div class="pcl-field-hr"></div>
	</li>
	<li>
		<label for="pcl_lock_mode"><?php _e('Lock Mode', 'pcl'); ?></label>
		<select name="pcl[lock_mode]" id="pcl_lock_mode" class="widefat">
			<option value="direct"<?php if ( pcl_isset($pcl['lock_mode']) == 'direct' ) echo ' selected="selected" '; ?>>Direct Lock</option>
			<option value="popup"<?php if ( pcl_isset($pcl['lock_mode']) == 'popup' ) echo ' selected="selected" '; ?>>PopUp Lock</option>
		</select>
		<div class="pcl-field-desc"><?php _e('Choose how you want to lock the content.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li>
		<label for="pcl_unlock"><?php _e('How To Unlock', 'pcl'); ?></label>
		<select name="pcl[unlock_type]" id="pcl_unlock" class="widefat">
			<option value="share"<?php if ( pcl_isset($pcl['unlock_type']) == 'share' ) echo ' selected="selected" '; ?>>Share To Social Sites To Unlock</option>
			<option value="optin"<?php if ( pcl_isset($pcl['unlock_type']) == 'optin' ) echo ' selected="selected" '; ?>>Opt-In To Unlock</option>
		</select>
		<div class="pcl-field-desc"><?php _e('Choose how visitors can unlock the content of this post/page.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	</ul>
	
	<ul id="pcl-set">
		<li class="pcl-optin-property">
		<label for="pcloptincta"><?php _e('Call To Action', 'pcl'); ?></label>
		<?php if ( post_type_supports('page', 'editor') ) : ?>
			<?php $optin_cta = ( isset($pcl['optin_cta']) ) ? stripslashes($pcl['optin_cta']) : pcl_default_msg('optin'); ?>
        	<?php wp_editor($optin_cta, 'pcloptincta', array('textarea_name' => 'pcl[optin_cta]' ) ); ?>
		<?php endif; ?>
		<div class="pcl-field-desc"><?php _e('Enter the call to action message to entice your visitors to subscribe, and unlock the content.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property">
		<label for="pcl_resp"><?php _e('Autoresponder/Opt-In Code', 'pcl'); ?></label>
		<textarea name="pcl[resp_code]" id="pcl_resp" class="widefat" style="height:120px"><?php echo stripslashes(pcl_isset($pcl['resp_code'])); ?></textarea>
		<div class="pcl-field-desc"><?php _e('Please enter the RAW HTML version of your autoresponder/opt-in form code from your email marketing service provider (i.e. Aweber, GetResponse, iContact, MailChimp, etc).', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property">
		<label><?php _e('How To Subscribe', 'pcl'); ?></label>
		<label for="pcl_manual_subs" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[manual_subs]" id="pcl_manual_subs" value="1"<?php if ( pcl_isset($pcl['manual_subs']) == 1 ) echo ' checked="checked" '; ?> <?php if ( !isset($pcl['manual_subs']) ) echo ' checked="checked" '; ?> /> <span class="pcl-field-desc"><code><?php _e('Use Standard Opt-In Form', 'pcl'); ?></code></span></label><br />
		<label for="pcl_fb_subs" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[fb_subs]" id="pcl_fb_subs" value="1"<?php if ( pcl_isset($pcl['fb_subs']) == 1 ) echo ' checked="checked" '; ?> <?php if ( !isset($pcl['fb_subs']) ) echo ' checked="checked" '; ?> /> <span class="pcl-field-desc"><code><?php _e('Use Facebook Connect', 'pcl'); ?></code></span></label><br />
		<div class="pcl-field-desc"><?php _e('Choose how your visitors can subscribe to your list, and unlock the content. Please note that pepcle who subscribed using Facebook will also be added to your autoresponder list.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-manual-subs-property">
		<label for="name_field_label"><?php _e('Name Field Label', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[name_field]" id="name_field_label" value="<?php if ( isset($pcl['name_field']) ) echo stripslashes($pcl['name_field']); else echo 'Your First Name'; ?>" />
		<div class="pcl-field-desc"><?php _e('Enter a text label for the name field (e.g. Your First Name).', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-manual-subs-property">
		<label for="email_field_label"><?php _e('Email Field Label', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[email_field]" id="email_field_label" value="<?php if ( isset($pcl['email_field']) ) echo stripslashes($pcl['email_field']); else echo 'Your Primary Email'; ?>" />
		<div class="pcl-field-desc"><?php _e('Enter a text label for the email field (e.g. Your Primary Email).', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-manual-subs-property">
		<label for="pcl_btn_color"><?php _e('Opt-In Button Color', 'pcl'); ?></label>
		<select name="pcl[btn_color]" id="pcl_btn_color" class="widefat">
			<option value="yellow"<?php if ( pcl_isset($pcl['btn_color']) == 'yellow' ) echo ' selected="selected" '; ?>>Yellow</option>
			<option value="orange"<?php if ( pcl_isset($pcl['btn_color']) == 'orange' ) echo ' selected="selected" '; ?>>Orange</option>
			<option value="red"<?php if ( pcl_isset($pcl['btn_color']) == 'red' ) echo ' selected="selected" '; ?>>Red</option>
			<option value="green"<?php if ( pcl_isset($pcl['btn_color']) == 'green' ) echo ' selected="selected" '; ?>>Green</option>
			<option value="blue"<?php if ( pcl_isset($pcl['btn_color']) == 'blue' ) echo ' selected="selected" '; ?>>Blue</option>
			<option value="grey"<?php if ( pcl_isset($pcl['btn_color']) == 'grey' ) echo ' selected="selected" '; ?>>Grey</option>
		</select>
		<div class="pcl-field-desc"><?php _e('Choose a color for the opt-in button.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-manual-subs-property">
		<label for="pcl_btn_label"><?php _e('Opt-In Button Label', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[btn_label]" id="pcl_btn_label" value="<?php if ( isset($pcl['btn_label']) ) echo stripslashes($pcl['btn_label']); else echo 'Subscribe Now!'; ?>" />
		<div class="pcl-field-desc"><?php _e('Enter a text label for the opt-in button (e.g. Subscribe).', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property">
		<label for="pcl_privacy"><?php _e('Privacy Notice', 'pcl'); ?></label>
		<textarea name="pcl[privacy]" id="pcl_privacy" class="widefat" style="height:60px"><?php if ( isset($pcl['privacy']) ) echo stripslashes($pcl['privacy']); else echo 'Your Privacy is SAFE'; ?></textarea>
		<div class="pcl-field-desc"><?php _e('Enter a short privacy policy text that will be shown under the opt-in form.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property">
		<label for="pcl_optinmsg"><?php _e('Thank You/Confirmation Message', 'pcl'); ?></label>
		<textarea name="pcl[optinmsg]" id="pcl_optinmsg" class="widefat" style="height:60px"><?php if ( isset($pcl['optinmsg']) ) echo stripslashes($pcl['optinmsg']); else echo 'Thank You For Subscribing. Please Confirm Your Email Address.'; ?></textarea>
		<div class="pcl-field-desc"><?php _e('Enter a short thank you or confirmation message that will be displayed after visitors subscribed to your list.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-fb-subs-property">
		<label for="pcl_fb_subs_title"><?php _e('Facebook Connect Title', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[fb_subs_title]" id="pcl_fb_subs_title" value="<?php if ( isset($pcl['fb_subs_title']) ) echo stripslashes($pcl['fb_subs_title']); else echo 'Or, Subscribe using your Facebook Account'; ?>" />
		<div class="pcl-field-desc"><?php _e('Enter a text that will be displayed above the Facebook connect button.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-fb-subs-property">
		<label for="pcl_fb_subs_label"><?php _e('Facebook Connect Button Label', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[fb_subs_label]" id="pcl_fb_subs_label" value="<?php if ( isset($pcl['fb_subs_label']) ) echo stripslashes($pcl['fb_subs_label']); else echo 'Subscribe With Facebook'; ?>" />
		<div class="pcl-field-desc"><?php _e('Enter a text label that will be displayed on the Facebook Connect button.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-optin-property pcl-fb-subs-property">
		<label for="pcl_fbopt_share" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[fbopt_share]" id="pcl_fbopt_share" value="1"<?php if ( pcl_isset($pcl['fbopt_share']) == 1 ) echo ' checked="checked" '; ?>/> <span class="pcl-field-desc"><code><?php _e('Auto-Share URL on visitors\' wall when they subscribe using Facebook', 'pcl'); ?></code></span></label>
		<div class="pcl-field-hr"></div>
	</li>
	</ul>
	
	<ul id="pcl-set">
	<li class="pcl-share-property">
		<label for="pclsharecta"><?php _e('Call To Action', 'pcl'); ?></label>
		<?php if ( post_type_supports('page', 'editor') ) : ?>
			<?php $share_cta = ( isset($pcl['share_cta']) ) ? stripslashes($pcl['share_cta']) : pcl_default_msg('share'); ?>
        	<?php wp_editor($share_cta, 'pclsharecta', array('textarea_name' => 'pcl[share_cta]' ) ); ?>
		<?php endif; ?>
		<div class="pcl-field-desc"><?php _e('Enter the call to action message to entice your visitors to share your site, and unlock the content.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-share-property">
		<label><?php _e('Share Options', 'pcl'); ?></label>
		<label for="pcl_fb_like" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[share][fb_like]" id="pcl_fb_like" value="1"<?php if ( pcl_isset($pcl['share']['fb_like']) == 1 ) echo ' checked="checked" '; ?><?php if ( !isset($pcl['share']['fb_like']) && !isset($pcl['unlock_type']) ) echo ' checked="checked" '; ?>/> <span class="pcl-field-desc"><code><?php _e('Facebook Like', 'pcl'); ?></code></span></label><br />
		<label for="pcl_fb_share" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[share][fb_share]" id="pcl_fb_share" value="1"<?php if ( pcl_isset($pcl['share']['fb_share']) == 1 ) echo ' checked="checked" '; ?><?php if ( !isset($pcl['share']['fb_share']) && !isset($pcl['unlock_type']) ) echo ' checked="checked" '; ?>/> <span class="pcl-field-desc"><code><?php _e('Facebook Share', 'pcl'); ?></code></span></label><br />
		<label for="pcl_tw_share" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[share][twitter]" id="pcl_tw_share" value="1"<?php if ( pcl_isset($pcl['share']['twitter']) == 1 ) echo ' checked="checked" '; ?><?php if ( !isset($pcl['share']['twitter']) && !isset($pcl['unlock_type']) ) echo ' checked="checked" '; ?>/> <span class="pcl-field-desc"><code><?php _e('Twitter', 'pcl'); ?></code></span></label><br />
		<label for="pcl_g1_share" style="display:inline;font-weight:normal"><input type="checkbox" name="pcl[share][google1]" id="pcl_g1_share" value="1"<?php if ( pcl_isset($pcl['share']['google1']) == 1 ) echo ' checked="checked" '; ?><?php if ( !isset($pcl['share']['google1']) && !isset($pcl['unlock_type']) ) echo ' checked="checked" '; ?>/> <span class="pcl-field-desc"><code><?php _e('Google +1', 'pcl'); ?></code></span></label><br />
		<div class="pcl-field-desc"><?php _e('Visitors can unlock the content by sharing your post/page/URL in one of the social sites above. Please select which social sites you want to include.'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-url-property">
		<label for="pcl_share_url"><?php _e('Custom URL To Share', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[share_url]" id="pcl_share_url" value="<?php echo stripslashes(pcl_isset($pcl['share_url'])); ?>" />
		<div class="pcl-field-desc"><?php _e('You can enter a URL if you want an external page to be shared in the social sites.<br />If you want THIS post/page to be shared, simply leave this blank.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	
	<li class="pcl-fb-property">
		<label for="fb_share_title"><?php _e('Facebook Share :: Title', 'pcl'); ?></label>
		<input class="widefat" type="text" name="pcl[fb_share][title]" id="fb_share_title" value="<?php echo stripslashes(pcl_isset($pcl['fb_share']['title'])); ?>" />
		<div class="pcl-field-desc"><?php _e('Enter a title for the Facebook share. If you leave this blank, then this post/page title will be used.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-fb-property">
		<label for="fb_share_desc"><?php _e('Facebook Share :: Short Description', 'pcl'); ?></label>
		<textarea name="pcl[fb_share][desc]" id="share_desc" class="widefat" style="height:80px"><?php echo stripslashes(pcl_isset($pcl['fb_share']['desc'])); ?></textarea>
		<div class="pcl-field-desc"><?php _e('Enter a short description for the Facebook share. If you leave this blank, then an excerpt from the post/page content will be used.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-fb-property">
		<label for="pcl_share_image"><?php _e('Facebook Share :: Thumbnail URL (optional)', 'pcl'); ?></label>
		<input type="text" name="pcl[image]" id="pcl_share_image" value="<?php echo pcl_isset($pcl['image']); ?>" class="widefat uploaded_url" style="width:75%;" />
		<span id="pcl_fb_upload-btn" class="pcl_upload_button button">Upload Thumbnail</span>
		<div class="pcl-field-desc"><?php _e('Enter an image or thumbnail URL or click the "Upload Thumbnail" button to upload a new one.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	<li class="pcl-twitter-property">
		<label for="pcl_twitter_msg"><?php _e('Twitter :: Tweet Message', 'pcl'); ?></label>
		<textarea name="pcl[twitter][msg]" id="pcl_twitter_msg" class="widefat" style="height:80px"><?php echo stripslashes(pcl_isset($pcl['twitter']['msg'])); ?></textarea>
		<div class="pcl-field-desc"><?php _e('Enter a short message that will be tweeted.', 'pcl'); ?></div>
		<div class="pcl-field-hr"></div>
	</li>
	</ul>
	<div style="clear:left"></div>
<?php
}

function pcl_save_meta( $post_id ) {
	$nonce = pcl_isset($_POST['_pcl_meta_nonce']);
	if ( !wp_verify_nonce($nonce, 'pcl-meta-nonce') )
		return $post_id;
    
	if ( 'page' == $_POST['post_type']  ) {
    		if ( !current_user_can( 'edit_page', $post_id ) ) return $post_id;
    	} else {
      		if ( !current_user_can( 'edit_post', $post_id ) ) return $post_id;
    	}
	
	if ( isset($_POST['pcl']) )
		update_post_meta( $post_id, 'pcl_meta', $_POST['pcl'] );

}

function pcl_default_msg( $type = 'share' ) {
	$default_cta = '
		<p>You can put some content here to tease your visitors. This is an example of text that will entice your visitors.</p>
		<p>Want to know what it is? Please read below...</p>
		<h2 style="text-align: center;"><span style="color: #cc0000;">The Content Is Locked!</span></h2>
		<p style="text-align: center;"><strong>How To Unlock This Content:</strong></p>
		<p style="text-align: center;">Simply click one of the share buttons below to reveal the content.</p>
	 ';
	 
	 $default_optin = '
	 	<p>You can put some content here to tease your visitors. This is an example of text that will entice your visitors.</p>
		<p>Want to know what it is? Please read below...</p>
		<h2 style="text-align: center;"><span style="color: #cc0000;">Private Content: For Subscribers Only!</span></h2>
		<p style="text-align: center;">Simply enter your name and email address below to unlock the content.</p>
	 ';
 
 	if ( $type == 'share' )
		return $default_cta;
	else
		return $default_optin;
}

// HOOKS

add_action( 'admin_menu', 'pcl_add_meta_box' );
add_action( 'save_post', 'pcl_save_meta' );