<?php
/*
Plugin Name: Premium Content Lock
Plugin URI: http://www.premiumcontentlock.com
Description: Social Traffic In Minutes, Guaranteed!
Version: 1.3
Author: Get Profits Fast
Author URI: http://www.getprofitsfast.com

Copyright 2012  Get Profits Fast (http://www.getprofitsfast.com)
*/

define( 'PCL_URL', plugin_dir_url(__FILE__) );
define( 'PCL_PATH', plugin_dir_path(__FILE__) );
define( 'PCL_BASENAME', plugin_basename( __FILE__ ) );

define( 'PCL_VERSION', '1.3' );
define( 'PCL_DB_VERSION', '0.01' );

if ( is_admin() ) {
	require_once( PCL_PATH . 'inc/admin.php' );
	require_once( PCL_PATH . 'inc/meta.php' );
} else {
	require_once( PCL_PATH . 'inc/functions.php' );
}

register_activation_hook( __FILE__, 'pcl_install');
function pcl_install() {
	global $wpdb;
}

function pcl_dump( $dump ) {
	echo '<pre>' . print_r($dump, true) . '</pre>';
}

function pcl_isset(&$value, $default= NULL) {
	if (isset($value)) $temp = $value;
	else $temp = $default;
	
	return $temp;
}

function pcl_format_url( $page_id, $query_str ) {

	$query_string = '';
	$link = '';
	$url = ( is_numeric($page_id) && $page_id > 0 ) ? get_permalink($page_id) : $page_id;

	if ( get_option('show_on_front') == 'page') {
		// this mean the page is on the front... so the format is
		if ( get_option('page_on_front') == $page_id ) {
			$query_string = '?' . $query_str;
			$link = trailingslashit($url) . $query_string;
		} else if ( get_option('page_for_front') != $page_id ) {
			if ( get_option('permalink_structure') == '' ) {
				if (strpos($url, '?'))
					$query_string = '&' . $query_str;
				else
					$query_string = '?' . $query_str;
					
				$link = $url . $query_string;
			} else {
				$query_string = '?' . $query_str;
				$link = trailingslashit($url) . $query_string;
			}
		}
	} else {
		// this mean the page is NOT on the front... so the format is
		if ( get_option('permalink_structure') == '' ) {
			if (strpos($url, '?'))
				$query_string = '&' . $query_str;
			else
				$query_string = '?' . $query_str;
					
			$link = $url . $query_string;
		} else {
			$query_string = '?' . $query_str;
			$link = trailingslashit($url) . $query_string;
		}
	}

	return $link;
}

function is_pcl_admin() {
	if ( is_user_logged_in() && current_user_can('manage_options') ) return true;

	return false;
}